/*
CB64 (tm) is copyright 1998-2001 by Johan Fiti.
Come Back 64 (tm) is copyright 1998-2001 by Johan Fiti.

Character ROM MOS901225-01, 1982 by Commodore Business Machines.
BASIC ROM MOS901226-01, 1982 by Commodore Business Machines, Microsoft Corp.
Kernal ROM MOS901227-03 (rev. 3), 1983 by Commodore Business Machines.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

// ### DEFINES ##############################################################
#ifndef SOUND_H
#define SOUND_H
#define PAL
#define ATTACK 0	//A of ADSR
#define DECAY 1		//D of ADSR
#define SUSTAIN 2	//S of ADSR
#define RELEASE 3	//R of ADSR

// ### TYPEDEFS ##############################################################
typedef struct {
        long length;
        long loopto;
        short *buf;
        }
sndsamp;
typedef struct {
        sndsamp *cursamp;
        long sampptr;
        unsigned long envx,envclk;
        int envstate;
        int ar,dr,sl,sr;
        int counter;
        }
sndvoice;

// ### EXTERN VARIABLES #####################################################
extern sndsamp *SNDsamples[256];
extern sndvoice SNDvoices[3];
extern unsigned char v1on,v2on,v3on;
extern short *SNDbuf;
extern long SNDfreq,SNDurate,SNDkeys,SNDmixlen,leds;

// ### ROUTINE DECLARATIONS #################################################
void Klight(unsigned char);
void SNDMix(void);
void SNDNoteOn(unsigned char);
void SNDNoteOff(unsigned char);
void SNDClose(long);
long SNDDoEnv(long);
int SNDInit(long,long);
long SNDStart(long);
#endif
